//---------------------------------------------------------------------------

#pragma hdrstop  
#include "enba_lib.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

int __fastcall nomal(int year, int mon, char buff[][256], int country, int ws, int vy);
int __fastcall jurius(int year, int mon, char buff[][256], int country, int ws, int vy);

unsigned long __fastcall Days(struct env_time* arg);
int __fastcall Week(int year, int mon, int day, int ws);
int __fastcall DayMax(int year, int month);

const char e_week[7][4] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
const char j_week[7][4] = {"", "", "", "", "", "", "y"};
//---------------------------------------------------------------------------

#pragma argsused
int main(int argc, char* argv[])
{

    int year = 0;
    int mon = 0;

    int n;

    int jur=0;
    int country=1;
    int ws=0;
    int mon_cnt=1;
    int cmd[2];
    int cmd_cnt=0;
    int opt=0;

    for (int i=1; i<argc; i++){
    	if (argv[i][0]=='/' || argv[i][0]=='-' && strlen(argv[i]) > 1) {
    		int j=1;
    		while (j < (int)strlen(argv[i])) {
		        if (argv[i][j] == 'j'){
		            jur=1;       opt++;
		        } else
		        if (argv[i][j] == 'u'){
		            country=0;   opt++;
		        } else
		        if (argv[i][j] == '1'){
		            mon_cnt=1;   opt++;
		        } else
		        if (argv[i][j] == '3'){
		            mon_cnt=3;   opt++;
		        } else
		        if (argv[i][j] == 'y'){
		            mon_cnt=12;  opt++;
		        } else
		        if (argv[i][j] == 'm'){
		            ws=1;        opt++;
		        } else
		        if (argv[i][j] == 's'){
		            ws=0;        opt++;
		        } else
		        if (argv[i][j] == 'V'){
		            printf ("cal from stiffels version 1.0\r\n");
                    return 0;
		        } else {
		            if (strlen(argv[i]) > 1) {
		                printf ("cal: unknown option -- %s\r\n", &argv[i][1]);
		            }
		            printf ("usage: cal [-mjyuV] [[month] year]\r\n");
		            return 1;
		        }
		        j++;
		    }
        }
        else {
            if (C_IsNumeric(argv[i]) && cmd_cnt < 2) {
                int d = atoi(argv[i]);
                if (argc-(opt>0)==3 && i-(opt>0)==1 && cmd_cnt==0) {
                    if (d>=1 && d<=12) {
                        mon = d;
                    } else {
                        printf ("cal: illegal mon value: use 1-12\r\n");
                        return 1;
                    }
                }
                else
                if (cmd_cnt<=1 && d>=1 && d<=9999) {
                    year = d;
                    if (cmd_cnt==0) {
                        mon_cnt = 12;
                    }
                }
                else {
                    printf ("cal: illegal year value: use 1-9999\r\n");
                    return 1;
                }
                cmd_cnt++;
            } else {
                printf ("cal: illegal year value: use 1-9999\r\n");
                return 1;
            }
        }
    }

    if (year==0) {
        year = atoi(C_Format_t(C_Now(),"YYYY"));
    }
	if (mon==0) {
	    mon = atoi(C_Format_t(C_Now(),"M"));
	}

    char buff[100][256];
    char tmp[10][256], tmp2[512];
    int yy=0, m=0, y=0, x=0, j, lines=0;
    for (int i=0; i < mon_cnt; i++) {

        y = i / (3-(jur-(mon_cnt==3)));
        x = i % (3-(jur-(mon_cnt==3)));

        yy = year;
        if (mon_cnt == 1) {
            m = mon;
        } else
        if (mon_cnt == 3) {
            m = mon-1 + i;
            if (m < 1 || m > 12) {
                yy = yy - (m==0) + (m==13);
                m = (m-1 + 12) % 12 + 1;
            }
        }
        else {
            m = 1 + i;
        }

	    if (jur == 0) {
	        n = nomal(yy,m,tmp, country, ws, (mon_cnt==12));
	    } else {
	        n = jurius(yy,m,tmp, country, ws, (mon_cnt==12));
	    }

        for (j=0; j<8; j++) {
            if (x==0) {
                buff[j + y*8][0]=='\0';
            } else {
                strcat(buff[j + y*8], "  ");
            }

            if (j <= n) {
                strcpy(tmp2, tmp[j]);
            }
            strcat(buff[j + y*8], tmp2);
            memset(tmp2, ' ', (jur? 27: 21)); tmp2[(jur? 27: 21)]='\0';
            strcat(buff[j + y*8], tmp2);
            C_CMid(tmp2, buff[j + y*8], 1, (x+1) * (jur? 27: 21) + 2*x);
            strcpy(buff[j + y*8], tmp2);
        }
    }

    if (jur==0 || mon_cnt==3) {
        lines =  ((mon_cnt-1) / 3 + 1) * 8;
    } else {
        lines =  ((mon_cnt-1) / 2 + 1) * 8;
    }

    if (mon_cnt==12){
        char tmp3[512];
        sprintf(tmp2,"%d",year);
        int w = (2 + (jur==0)) * (jur? 27: 21) + 1;
        setmem(tmp3, w, ' '); tmp3[w]='\0';
        strcat(tmp3, tmp2);
        C_CMid(tmp2, tmp3, strlen(tmp3) / 2);
        strcat(tmp2, "\r\n\r\n");
        printf(tmp2);
    }
    for (int i=0; i<lines; i++) {
        strcat(buff[i], "\r\n");
        printf(buff[i]);
    }

    return 0;
}
//---------------------------------------------------------------------------
int __fastcall nomal(int year, int mon, char buff[][256], int country, int ws, int vy)
{
    char tmp[512],tmp2[512];

    // N
    if (country == 0) {
        sprintf(tmp, "%04d/%02d/01",year,mon);
        strcpy(tmp2, C_Format_t(C_CDate(tmp), "mmmm"));
    } else {
        sprintf(tmp2,"%d" ,mon, year);
    }
    int i;
    if (vy==0) {
        sprintf(tmp,"%s %d",tmp2, year);
        strcpy(tmp2, tmp);
    }
    setmem(tmp, 20, ' '); tmp[20]='\0';
    strcat(tmp, tmp2);
    C_CMid(tmp2, tmp, strlen(tmp) / 2+1);
    strcpy(buff[0], tmp2);

    // j
    buff[1][0] = '\0';
    i=0;
    do {
        i++;
    } while (Week(year,mon,i,ws) !=0);

    do {
        if (country==0) {
            strcpy(tmp2, e_week[Week(year,mon,i,0)]);
            tmp2[2]=' ';
            tmp2[3]='\0';
        } else {
            sprintf(tmp2, "%s ", j_week[Week(year,mon,i,0)]);
        }
        strcat(buff[1],tmp2);
        i++;
    } while (Week(year,mon,i,ws) != 0);

    // ɂ
    buff[2][0] = '\0';
    for (i=0;i< Week(year,mon,1,ws);i++) strcat(buff[2],"   ");

    int n=2;
    for (int i=1;i<=DayMax(year,mon);i++){

        int e = year  * 10000
              + mon   *   100
              + i;

        if (e > 17520902 && e < 17520914) {
            continue;
        }

        sprintf(tmp,"   %d ", i);
        C_Right(tmp2, tmp, 3);
        strcat(buff[n],tmp2);
        if (Week(year,mon,i,ws) == 6) {
            n++;
            buff[n][0]='\0';
        }
    }
    while (n<8) {
        n++;
        buff[n][0]='\0';
    }
    return n;
}
//---------------------------------------------------------------------------
int __fastcall jurius(int year, int mon, char buff[][256], int country, int ws, int vy)
{
    char tmp[512],tmp2[512],tmp3[512];

    if (country == 0) {
        sprintf(tmp, "%04d/%02d/01",year,mon);
        strcpy(tmp2, C_Format_t(C_CDate(tmp), "mmmm"));
    } else {
        sprintf(tmp2,"%d" ,mon);
    }
    int i;
    if (vy==0) {
        sprintf(tmp,"%s %04d",tmp2, year);
        strcpy(tmp2, tmp);
    }
    setmem(tmp, 26, ' '); tmp[26]='\0';
    strcat(tmp, tmp2);
    C_CMid(tmp2, tmp, strlen(tmp) / 2+1);
    strcpy(buff[0], tmp2);

    // j
    buff[1][0] = '\0';
    i=0;
    do {
        i++;
    } while (Week(year,mon,i,ws) !=0);

    do {
        if (country==0) {
            sprintf(tmp2, "%s ", e_week[Week(year,mon,i,0)]);
        } else {
            sprintf(tmp2, " %s ", j_week[Week(year,mon,i,0)]);
        }
        strcat(buff[1],tmp2);
        i++;
    } while (Week(year,mon,i,ws) != 0);

    buff[2][0] = '\0';
    for (i=0;i< Week(year,mon,1,ws);i++) strcat(buff[2],"    ");

    int juri;
    int n=2;  

    int e = year  * 10000
          + mon   *   100
          + 1;

    sprintf(tmp, "%04d/%02d/%02d",year,mon,1);
    sprintf(tmp3, "%04d/1/1",year);
    juri = Days(C_CDate(tmp)) - Days(C_CDate(tmp3)) + 1;
    if (year == 1752 && e > 17520902) juri += 13;

    for (i=1;i<=DayMax(year,mon);i++){

        e = year  * 10000
          + mon   *   100
          + i;

        if (e > 17520902 && e < 17520914) {
            continue;
        }

        sprintf(tmp2,"   %d ", juri);
        C_Right(tmp, tmp2, 4);
        strcat(buff[n],tmp);
        if (Week(year,mon,i,ws) == 6) {
            n++;
            buff[n][0]='\0';
        }
        juri++;
        if (e == 17520902) juri = 258;
    }
    while (n<8) {
        n++;
        buff[n][0]='\0';
    }
    return n;
}
//---------------------------------------------------------------------------
unsigned long __fastcall Days(struct env_time* arg)
{

    int e = arg->year  * 10000
          + arg->mon   *   100
          + arg->day;

    int year = arg->year;
    int mon  = arg->mon;
    int day  = arg->day;

    unsigned long days;  
    if(mon < 3){
        year--;
        mon += 12;
    }
    if (e < 17520903) { // EXƃOSI̓]
        days = 365 * year + (year / 4) + (306 * (mon + 1) / 10) + day - 428;
    } else {
        days = 365 * year + (year / 4) - (year / 100) + (year / 400) + (306 * (mon + 1) / 10) + day - 428;
    }
    return days;
}
//---------------------------------------------------------------------------
int __fastcall Week(int year, int mon, int day, int ws)
{
    int e = year  * 10000
          + mon   *   100
          + day;

    unsigned long days;  
    if(mon < 3){
        year--;
        mon += 12;
    }
    if (e < 17520903) { // EXƃOSI̓]
        days = 365 * year + (year / 4) + (306 * (mon + 1) / 10) + day - 428 + 12;
    } else {
        days = 365 * year + (year / 4) - (year / 100) + (year / 400) + (306 * (mon + 1) / 10) + day - 428;
    }

    return (days + 7 - ws) % 7;
}
//---------------------------------------------------------------------------
int __fastcall DayMax(int year, int month)
{
	const int Cnt_Of_Days[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

	if(month > 12 || month < 1) return 0;

    int uruu;
    if (year * 100 + month < 175209) {
        uruu = (month == 2 && year%4 == 0); // EX
    } else {
        uruu = (month == 2 && year%4 == 0 && (year%100!=0 || year%400==0)); // OSI
    }

	return Cnt_Of_Days[month - 1] + uruu;
}
//---------------------------------------------------------------------------
